package it.polito.esame;

import it.polito.esame.bean.Parola;

import java.util.List;

import org.jgrapht.GraphPath;
import org.jgrapht.Graphs;
import org.jgrapht.UndirectedGraph;
import org.jgrapht.alg.DijkstraShortestPath;
import org.jgrapht.graph.DefaultEdge;
import org.jgrapht.graph.SimpleGraph;

public class ModelT1 {
	
	private int lun ;
	
	public int getLun() {
		return lun;
	}

	private List<Parola> listaParole ;
	
	private UndirectedGraph<Parola, DefaultEdge> graph ;

	public List<Parola> getListaParole() {
		return listaParole;
	}

	public void setListaParole(List<Parola> listaParole, int lun) {
		this.listaParole = listaParole;
		this.lun = lun ;
	}

	public UndirectedGraph<Parola, DefaultEdge> getGraph() {
		return graph;
	}	
	
	public void createGraph() {
		graph = new SimpleGraph<>(DefaultEdge.class) ;
		 
		Graphs.addAllVertices(graph, listaParole) ;
		
		for( Parola p : listaParole ) {
			for( Parola q : listaParole ) {
				if(q!=p) {
					if( p.similarTo(q) )
						graph.addEdge(p, q) ;
				}
			}
		}
	}

	public List<Parola> trovaPercorso(Parola parola, Parola parola2) {

		DijkstraShortestPath<Parola, DefaultEdge> dijstra = new DijkstraShortestPath<Parola, DefaultEdge>(graph, parola, parola2) ;
		
		GraphPath<Parola, DefaultEdge> path = dijstra.getPath() ;
		
		if(path==null)
			return null ;
		
		List<Parola> percorso = Graphs.getPathVertexList(path) ;

		return percorso;
	}

	public int getNumConn(Parola p) {
		return graph.degreeOf(p) ;
	}
	

}
